// File [Server]
import java.net.*;
import java.io.*;

public class Server {
	private int tiposerver;
	
	public Server(int tiposerver) {
		this.tiposerver=tiposerver;
	}
	
	public void Lancia() {
		String indaltroserver,nome;
		int portaaltroserver,portaperclient,portaperserver;
		
		if (tiposerver==0) { //master
			nome="master";
			indaltroserver=Def.indSlave;
			portaaltroserver=Def.portaSlaveMaster;
			portaperclient=Def.portaMaster;
			portaperserver=Def.portaMasterSlave;
		} else { //slave
			nome="slave";
			indaltroserver=Def.indMaster;
			portaaltroserver=Def.portaMasterSlave;
			portaperclient=Def.portaSlave;
			portaperserver=Def.portaSlaveMaster;
		}
		System.out.println("--------------------------------------");
		try {
			Socket connMS1 = new Socket(indaltroserver,portaaltroserver);
			Socket connMS2 = new Socket(indaltroserver,portaaltroserver);
			System.out.println("Server " + nome + " inizia sincronizzazione");
			Ascolta sincronizza = new Ascolta(3,connMS1,connMS2,tiposerver);
			sincronizza.start();
		} catch (IOException io) {
			try {
				System.out.println("Solo server " + nome + " attivo");
				Film film = new Film();
				ServerSocket client = new ServerSocket(portaperclient);
				ServerSocket masterslave = new ServerSocket(portaperserver);
				Ascolta attendialtroserver = new Ascolta(0,film,masterslave,tiposerver);
				attendialtroserver.start();
				Socket conn;
				while (true) {
					conn=client.accept();
					Ascolta ascoltaclient = new Ascolta(1,film,conn,tiposerver);
					ascoltaclient.start();
				}
			} catch (IOException io1) {
				System.out.println("Il server " + nome + "  caduto");
			}
		}
	}
}