//File [SemaforoFCFS]
import java.util.Vector;
public class SemaforoFCFS {
	//semaforo binario con politica First Come First Served
	private int contatore;
	private Vector inattesa = new Vector();
	
	public SemaforoFCFS(int contatore) {
		this.contatore=contatore; //valore 0 occupato o 1 libero
	}
	
	public synchronized void Entra() {
		if (contatore==0) {
			inattesa.addElement(new Coppia(Thread.currentThread(),false));
			while (true) {
				try {
					wait();
				} catch (InterruptedException ie) {}
				Coppia c = (Coppia) inattesa.firstElement();
				if (c.id==Thread.currentThread()&&c.sveglia) {
					inattesa.removeElementAt(0);
					break;
				}
			}
		}
		contatore = 0;
	}
	
	public synchronized void Esci() {
		if (contatore==0) {
			if (inattesa.size()==0) contatore = 1;
			else {
				((Coppia) inattesa.firstElement()).sveglia=true;
				notifyAll();
			}
		}
	}
}
			